{
Ŀ
                              MOUSE-SHARP                                  
⥪  ࠡ  ஬ ""  ணࠬ  TurboPascal 7.0
                      Coded by VanDamM, 14-07-97                           
                          All right reserved                               

}
{F+}
Unit M_SHARP;
Interface
Var
    MouseX, MouseY, LeftKey, RightKey, MiddleKey : integer;
    Status, KeyNumber, HorizMove, VertMove, DSpeed : integer;
    ButtonNum, ButtonX, ButtonY, HorizCount, VertCount : integer;

    Procedure MouseInit;

    Procedure MouseGoToXY(GoX, GoY : integer);

    Procedure MouseOn;

    Procedure MouseOff;

    Procedure MouseLimitVert(LimitXmin, LimitXmax : integer);

    Procedure MouseLimitHorz(LimitYmin, LimitYmax : integer);

    Procedure MouseInitGraph(HotX, HotY : integer; Mask : array of word);

    Procedure MouseInitText(CursorType : integer; AndMask, XorMask : word);

    Procedure MouseSetMove(HorizSMove, VertSMove : integer);

    Procedure MouseGetMove;

    Procedure MouseSetDoubleSpeed(Porog : integer);

    Procedure MouseStatus;

    Procedure MouseSetPressNum(KeyIdentificator : integer);

    Procedure MouseSetFreeNum(KeyIdentificator : integer);

    Procedure MouseCounter;

Implementation

    Procedure MouseInit;
     Begin
      asm
        mov ax, 0000h
        int 33h
        mov Status, ax
        mov KeyNumber, bx
      end;
     End;

    Procedure MouseOn;
     Begin
      asm
       mov ax, 0001h
       int 33h
      end;
     End;

    Procedure MouseOff;
     Begin
      asm
       mov ax, 0002h
       int 33h
      end;
     End;

    Procedure MouseGoToXY(GoX, GoY : integer);
     Begin
      asm
        mov ax, 0004h
        mov cx, GoX
        mov dx, GoY
        int 33h
      end;
     End;

    Procedure MouseLimitVert(LimitXmin, LimitXmax : integer);
     Begin
      asm
        mov ax, 0007h
        mov cx, LimitXmin
        mov dx, LimitXmax
        int 33h
      end;
     End;

    Procedure MouseLimitHorz(LimitYmin, LimitYmax : integer);
     Begin
      asm
        mov ax, 0008h
        mov cx, LimitYmin
        mov dx, LimitYmax
        int 33h
      end;
     End;

    Procedure MouseInitText(CursorType : integer; AndMask, XorMask : word);
     Begin
      asm
        mov ax, 000Ah
        mov bx, CursorType
        mov cx, AndMask
        mov dx, XorMask
        int 33h
      end;
     End;

    Procedure MouseInitGraph(HotX, HotY : integer; Mask : array of word);
     Begin
      asm
        mov ax, 0009h
        mov bx, HotX
        mov cx, HotY
        push cx
        mov cx, ds
        mov es, cx
        pop cx
        mov dx, offset Mask-6
        int 33h
      end;
     End;

    Procedure MouseSetMove(HorizSMove, VertSMove : integer);
     Begin
      asm
       mov ax, 000Fh
       mov cx, HorizSMove
       mov dx, VertSMove
       int 33h
      end;
     End;

    Procedure MouseGetMove;
     Begin
      asm
       mov ax, 001Bh
       int 33h
       mov HorizMove, bx
       mov VertMove, cx
       mov DSpeed, dx
      end;
     End;

    Procedure MouseSetDoubleSpeed(Porog : integer);
     Begin
      asm
       mov ax, 0013h
       mov dx, Porog
       int 33h
      end;
     End;

    Procedure MouseSetPressNum(KeyIdentificator : integer);
     Begin
      asm
       mov ax, 0005h
       mov bx, KeyIdentificator
       int 33h
       mov ButtonNum, bx
       mov ButtonX, cx
       mov ButtonY, dx
      end;
     End;

    Procedure MouseSetFreeNum(KeyIdentificator : integer);
     Begin
      asm
       mov ax, 0006h
       mov bx, KeyIdentificator
       int 33h
       mov ButtonNum, bx
       mov ButtonX, cx
       mov ButtonY, dx
      end;
     End;

    Procedure MouseCounter;
     Begin
      asm
       mov ax, 000bh
       int 33h
       mov HorizCount, cx
       mov VertCount, dx
      end;
     End;

    Procedure MouseStatus;
      Label Mouse1, Mouse2, Mouse3, Mouse4, Mouse5, Mouse6;
     Begin
      asm
        mov ax, 0003h
        int 33h

        mov MouseX, CX
        mov MouseY, DX
        push bx
        xor bl, 00000001b
        pop bx
        jnz Mouse2
        mov LeftKey,1
        jmp Mouse1
Mouse2:
        mov LeftKey,0
Mouse1:
        push bx
        xor bl, 00000010b
        pop bx
        jnz Mouse4
        mov RightKey,1
        jmp Mouse3
Mouse4:
        mov RightKey,0
Mouse3:
        xor bl, 00000100b
        jnz Mouse6
        mov MiddleKey,1
        jmp Mouse5
Mouse6:
        mov MiddleKey,0
Mouse5:
     End;
    End;
End.